import os
import sys
from pprint import pprint

from Models.Interpreter.Error import Error, ErrorCode
from ServiceInitializer import ServiceInitializer


class Main:

    def __init__(self) -> None:
        self.__services = ServiceInitializer()
        self.__utils = self.__services.utils
        self.__repo = self.__services.repo
        self.__interpreter = self.__services.interpreter

    def console(self) -> None:
        """
        Getting code from console input
        :return:
        """
        i = 0
        while self.__repo.is_error is not None:
            self.__utils.line_number = i + 1
            self.__interpreter.interpret(self.__utils.line_number, input('> '))
            i += 1

    def files(self, file: str) -> None:
        """
        Getting input from file
        :param file:
        :return:
        """
        if os.path.isfile(file):
            f = open(file, 'r', encoding='utf-8').readlines()
            for i in range(0, len(f)):
                self.__utils.line_number = i + 1
                self.__interpreter.interpret(f[i])

            print(self.__repo.AST)
        else:
            self.__utils.is_error(Error(ErrorCode.FileNotFound))


if __name__ == '__main__':
    main = Main()
    print(sys.argv)
    if len(sys.argv) == 2:
        main.files(sys.argv[1])
    else:
        main.console()
