from enum import Enum


class ErrorCode(Enum):
    StartFailed = 'Start failed'
    FileNotFound = 'File not found'

    Unknown = 'Unknown {}'
    Inaccessible = '{} inaccessible'
    Unexpected = 'Unexpected {}'
    Expected = 'Expected {}'

    LibInLib = 'Lib in lib'
    LibInClass = 'Lib in class'
    LibInFunc = 'Lib in func'
    ClassInClass = 'Class in class'
    ClassInFunc = 'Class in func'
    FuncInLib = 'Func in lib'
    FuncInFunc = 'Func in func'


class Error:

    def __init__(self, code: ErrorCode, msg: str = ''):
        self.code = code

        self.msg = code.value.format(msg)
